

   MEMBER('embeds.clw')                                    ! This is a MEMBER module


   INCLUDE('ABRESIZE.INC'),ONCE
   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('EMBEDS006.INC'),ONCE        !Local module procedure declarations
                     END


!!! <summary>
!!! Generated from procedure template - Window
!!! Form Embed
!!! </summary>
UpdateEmbed PROCEDURE 

!embed
CurrentTab           STRING(80)                            !
ActionMessage        CSTRING(40)                           !
!embed
History::EMB:Record  LIKE(EMB:RECORD),THREAD
!embed
QuickWindow          WINDOW('Form Embed'),AT(,,163,118),FONT('MS Sans Serif',8,,FONT:regular),RESIZE,CENTER,GRAY, |
  IMM,MDI,HLP('UpdateEmbed'),SYSTEM
                       SHEET,AT(4,4,155,92),USE(?CurrentTab)
                         TAB('&1) General'),USE(?Tab:1)
                           PROMPT('Embed ID:'),AT(8,20),USE(?EMB:EmbedID:Prompt),TRN
                           ENTRY(@n-14),AT(68,20,64,10),USE(EMB:EmbedID)
                           PROMPT('Embed Proc ID:'),AT(8,34),USE(?EMB:EmbedProcID:Prompt),TRN
                           ENTRY(@n-14),AT(68,34,64,10),USE(EMB:EmbedProcID)
                           PROMPT('Lines Of Code:'),AT(8,48),USE(?EMB:LinesOfCode:Prompt),TRN
                           ENTRY(@n-14),AT(68,48,64,10),USE(EMB:LinesOfCode)
                           PROMPT('Embed:'),AT(8,62),USE(?EMB:Embed:Prompt),TRN
                           TEXT,AT(68,62,87,30),USE(EMB:Embed)
                         END
                       END
                       BUTTON('&OK'),AT(4,100,49,14),USE(?OK),LEFT,ICON('WAOK.ICO'),DEFAULT,FLAT,MSG('Accept dat' & |
  'a and close the window'),TIP('Accept data and close the window')
                       BUTTON('&Cancel'),AT(57,100,49,14),USE(?Cancel),LEFT,ICON('WACANCEL.ICO'),FLAT,MSG('Cancel operation'), |
  TIP('Cancel operation')
                       BUTTON('&Help'),AT(110,100,49,14),USE(?Help),LEFT,ICON('WAHELP.ICO'),FLAT,MSG('See Help Window'), |
  STD(STD:Help),TIP('See Help Window')
                     END

!embed
ThisWindow           CLASS(WindowManager)
Ask                    PROCEDURE(),DERIVED
ChangeAction           PROCEDURE(),BYTE,DERIVED
DeleteAction           PROCEDURE(),BYTE,DERIVED
Init                   PROCEDURE(),BYTE,PROC,DERIVED
InsertAction           PROCEDURE(),BYTE,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Open                   PROCEDURE(),DERIVED
Open                   PROCEDURE(*Window pWindow,<*Window pOwner>),DERIVED
PrimeFields            PROCEDURE(),PROC,DERIVED
PrimeUpdate            PROCEDURE(),BYTE,PROC,DERIVED
Reset                  PROCEDURE(BYTE Force=0),DERIVED
RestoreField           PROCEDURE(SIGNED Control),DERIVED
Run                    PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED
SaveOnChangeAction     PROCEDURE(),BYTE,DERIVED
SaveOnInsertAction     PROCEDURE(),BYTE,DERIVED
SetAlerts              PROCEDURE(),DERIVED
SetResponse            PROCEDURE(BYTE Response),DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
TakeCloseEvent         PROCEDURE(),BYTE,PROC,DERIVED
TakeCompleted          PROCEDURE(),BYTE,PROC,DERIVED
TakeDisableButton      PROCEDURE(SIGNED Control,BYTE MakeDisable),DERIVED
TakeEvent              PROCEDURE(),BYTE,PROC,DERIVED
TakeFieldEvent         PROCEDURE(),BYTE,PROC,DERIVED
TakeWindowEvent        PROCEDURE(),BYTE,PROC,DERIVED
Update                 PROCEDURE(),DERIVED
                     END

Toolbar              CLASS(ToolbarClass)
DisplayButtons         PROCEDURE(),DERIVED
Init                   PROCEDURE()
Kill                   PROCEDURE(),DERIVED
TakeEvent              PROCEDURE(<*LONG VCR>,WindowManager WM),DERIVED
                     END

Resizer              CLASS(WindowResizeClass)
GetParentControl       PROCEDURE(SIGNED Control),SIGNED,DERIVED
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
Reset                  PROCEDURE(),DERIVED
Resize                 PROCEDURE(),BYTE,PROC,DERIVED
Resize                 PROCEDURE(SIGNED Control),BYTE,PROC,DERIVED
RestoreWindow          PROCEDURE(),DERIVED
SetParentDefault       PROCEDURE(),DERIVED
SetParentDefaults      PROCEDURE(),DERIVED
SetPosition            PROCEDURE(SIGNED Control,*PositionGroup ParentOrigPos,*PositionGroup ParentNewPos,*PositionGroup OrigPos,*PositionGroup NewPos),DERIVED
                     END

!embed
CurCtrlFeq          LONG
FieldColorQueue     QUEUE
Feq                   LONG
OldColor              LONG
                    END
!embed

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!embed
!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!embed
!embed
!---------------------------------------------------------------------------
!embed

ThisWindow.Ask PROCEDURE

!embed
  CODE
!embed
  CASE SELF.Request                                        ! Configure the action message text
  OF ViewRecord
    ActionMessage = 'View Record'
  OF InsertRecord
    ActionMessage = 'Record Will Be Added'
  OF ChangeRecord
    ActionMessage = 'Record Will Be Changed'
  END
  QuickWindow{PROP:Text} = ActionMessage                   ! Display status message in title bar
!embed
  PARENT.Ask
!embed


ThisWindow.ChangeAction PROCEDURE

ReturnValue          BYTE,AUTO

!embed
  CODE
!embed
  ReturnValue = PARENT.ChangeAction()
!embed
  RETURN ReturnValue


ThisWindow.DeleteAction PROCEDURE

ReturnValue          BYTE,AUTO

!embed
  CODE
!embed
  ReturnValue = PARENT.DeleteAction()
!embed
  RETURN ReturnValue


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

!embed
  CODE
!embed
  GlobalErrors.SetProcedureName('UpdateEmbed')
!embed
  SELF.Request = GlobalRequest                             ! Store the incoming request
!embed
  ReturnValue = PARENT.Init()
!embed
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?EMB:EmbedID:Prompt
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
!embed
!embed
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
!embed
  SELF.HistoryKey = CtrlH
  SELF.AddHistoryFile(EMB:Record,History::EMB:Record)
  SELF.AddHistoryField(?EMB:EmbedID,2)
  SELF.AddHistoryField(?EMB:EmbedProcID,4)
  SELF.AddHistoryField(?EMB:LinesOfCode,5)
  SELF.AddHistoryField(?EMB:Embed,6)
  SELF.AddUpdateFile(Access:Embed)
  SELF.AddItem(?Cancel,RequestCancelled)                   ! Add the cancel control to the window manager
!embed
  Relate:Embed.Open                                        ! File Embed used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  SELF.Primary &= Relate:Embed
  IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing ! Setup actions for ViewOnly Mode
    SELF.InsertAction = Insert:None
    SELF.DeleteAction = Delete:None
    SELF.ChangeAction = Change:None
    SELF.CancelAction = Cancel:Cancel
    SELF.OkControl = 0
  ELSE
    SELF.ChangeAction = Change:Caller                      ! Changes allowed
    SELF.CancelAction = Cancel:Cancel+Cancel:Query         ! Confirm cancel
    SELF.OkControl = ?OK
    IF SELF.PrimeUpdate() THEN RETURN Level:Notify.
  END
!embed
  SELF.Open(QuickWindow)                                   ! Open window
!embed
  Do DefineListboxStyle
!embed
  IF SELF.Request = ViewRecord                             ! Configure controls for View Only mode
    ?EMB:EmbedID{PROP:ReadOnly} = True
    ?EMB:EmbedProcID{PROP:ReadOnly} = True
    ?EMB:LinesOfCode{PROP:ReadOnly} = True
  END
!embed
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
!embed
  INIMgr.Fetch('UpdateEmbed',QuickWindow)                  ! Restore window settings from non-volatile store
!embed
  Resizer.Resize                                           ! Reset required after window size altered by INI manager
!embed
!embed
  SELF.SetAlerts()
!embed
  RETURN ReturnValue


ThisWindow.InsertAction PROCEDURE

ReturnValue          BYTE,AUTO

!embed
  CODE
!embed
  ReturnValue = PARENT.InsertAction()
!embed
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

!embed
  CODE
!embed
!embed
  ReturnValue = PARENT.Kill()
!embed
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
!embed
    Relate:Embed.Close
!embed
  END
!embed
  IF SELF.Opened
    INIMgr.Update('UpdateEmbed',QuickWindow)               ! Save window data to non-volatile store
  END
!embed
  GlobalErrors.SetProcedureName
!embed
  RETURN ReturnValue


ThisWindow.Open PROCEDURE

!embed
  CODE
!embed
  PARENT.Open
!embed


ThisWindow.Open PROCEDURE(*Window pWindow,<*Window pOwner>)

!embed
  CODE
!embed
  PARENT.Open(pWindow,pOwner)
!embed


ThisWindow.PrimeFields PROCEDURE

!embed
  CODE
!embed
!embed
  PARENT.PrimeFields
!embed


ThisWindow.PrimeUpdate PROCEDURE

ReturnValue          BYTE,AUTO

!embed
  CODE
!embed
  ReturnValue = PARENT.PrimeUpdate()
!embed
  RETURN ReturnValue


ThisWindow.Reset PROCEDURE(BYTE Force=0)

!embed
  CODE
!embed
  SELF.ForcedReset += Force
  IF QuickWindow{Prop:AcceptAll} THEN RETURN.
!embed
!embed
!embed
  PARENT.Reset(Force)
!embed


ThisWindow.RestoreField PROCEDURE(SIGNED Control)

!embed
  CODE
!embed
  PARENT.RestoreField(Control)
!embed


ThisWindow.Run PROCEDURE

ReturnValue          BYTE,AUTO

!embed
  CODE
!embed
  ReturnValue = PARENT.Run()
!embed
  IF SELF.Request = ViewRecord                             ! In View Only mode always signal RequestCancelled
    ReturnValue = RequestCancelled
  END
!embed
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

!embed
  CODE
!embed
  ReturnValue = PARENT.Run(Number,Request)
!embed
  RETURN ReturnValue


ThisWindow.SaveOnChangeAction PROCEDURE

ReturnValue          BYTE,AUTO

!embed
  CODE
!embed
  ReturnValue = PARENT.SaveOnChangeAction()
!embed
  RETURN ReturnValue


ThisWindow.SaveOnInsertAction PROCEDURE

ReturnValue          BYTE,AUTO

!embed
  CODE
!embed
  ReturnValue = PARENT.SaveOnInsertAction()
!embed
  RETURN ReturnValue


ThisWindow.SetAlerts PROCEDURE

!embed
  CODE
!embed
  PARENT.SetAlerts
!embed


ThisWindow.SetResponse PROCEDURE(BYTE Response)

!embed
  CODE
!embed
  PARENT.SetResponse(Response)
!embed


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

!embed
Looped BYTE
!embed
  CODE
!embed
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
!embed
    CASE ACCEPTED()
    OF ?CurrentTab
!embed
    OF ?EMB:EmbedID
!embed
    OF ?EMB:EmbedProcID
!embed
    OF ?EMB:LinesOfCode
!embed
    OF ?EMB:Embed
!embed
    OF ?OK
!embed
    OF ?Cancel
!embed
    OF ?Help
!embed
!embed
    ELSE
!embed
    END
!embed
  ReturnValue = PARENT.TakeAccepted()
!embed
    CASE ACCEPTED()
    OF ?CurrentTab
!embed
!embed
    OF ?EMB:EmbedID
!embed
!embed
    OF ?EMB:EmbedProcID
!embed
!embed
    OF ?EMB:LinesOfCode
!embed
!embed
    OF ?EMB:Embed
!embed
!embed
    OF ?OK
      ThisWindow.Update
!embed
!embed
      IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing THEN
         POST(EVENT:CloseWindow)
      END
!embed
    OF ?Cancel
      ThisWindow.Update
!embed
!embed
    OF ?Help
      ThisWindow.Update
!embed
!embed
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
!embed
  RETURN ReturnValue


ThisWindow.TakeCloseEvent PROCEDURE

ReturnValue          BYTE,AUTO

!embed
  CODE
!embed
  ReturnValue = PARENT.TakeCloseEvent()
!embed
  RETURN ReturnValue


ThisWindow.TakeCompleted PROCEDURE

ReturnValue          BYTE,AUTO

!embed
Looped BYTE
!embed
  CODE
!embed
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
!embed
  ReturnValue = PARENT.TakeCompleted()
!embed
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
!embed
  RETURN ReturnValue


ThisWindow.TakeDisableButton PROCEDURE(SIGNED Control,BYTE MakeDisable)

!embed
  CODE
!embed
  PARENT.TakeDisableButton(Control,MakeDisable)
!embed


ThisWindow.TakeEvent PROCEDURE

ReturnValue          BYTE,AUTO

!embed
Looped BYTE
!embed
  CODE
!embed
  LOOP                                                     ! This method receives all events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
!embed
  ReturnValue = PARENT.TakeEvent()
!embed
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
!embed
  RETURN ReturnValue


ThisWindow.TakeFieldEvent PROCEDURE

ReturnValue          BYTE,AUTO

!embed
Looped BYTE
!embed
  CODE
!embed
  LOOP                                                     ! This method receives all field specific events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
!embed
  CASE FIELD()
!embed
  OF ?CurrentTab
!embed
    CASE EVENT()
!embed
    OF EVENT:TabChanging
!embed
    ELSE
!embed
    END
!embed
  OF ?Tab:1
!embed
    CASE EVENT()
!embed
    ELSE
!embed
    END
!embed
  OF ?EMB:EmbedID:Prompt
!embed
    CASE EVENT()
!embed
    ELSE
!embed
    END
!embed
  OF ?EMB:EmbedID
!embed
    CASE EVENT()
!embed
    ELSE
!embed
    END
!embed
  OF ?EMB:EmbedProcID:Prompt
!embed
    CASE EVENT()
!embed
    ELSE
!embed
    END
!embed
  OF ?EMB:EmbedProcID
!embed
    CASE EVENT()
!embed
    ELSE
!embed
    END
!embed
  OF ?EMB:LinesOfCode:Prompt
!embed
    CASE EVENT()
!embed
    ELSE
!embed
    END
!embed
  OF ?EMB:LinesOfCode
!embed
    CASE EVENT()
!embed
    ELSE
!embed
    END
!embed
  OF ?EMB:Embed:Prompt
!embed
    CASE EVENT()
!embed
    ELSE
!embed
    END
!embed
  OF ?EMB:Embed
!embed
    CASE EVENT()
!embed
    ELSE
!embed
    END
!embed
  OF ?OK
!embed
    CASE EVENT()
!embed
    ELSE
!embed
    END
!embed
  OF ?Cancel
!embed
    CASE EVENT()
!embed
    ELSE
!embed
    END
!embed
  OF ?Help
!embed
    CASE EVENT()
!embed
    ELSE
!embed
    END
!embed
  END
!embed
  ReturnValue = PARENT.TakeFieldEvent()
!embed
  CASE FIELD()
!embed
  OF ?CurrentTab
!embed
    CASE EVENT()
!embed
    OF EVENT:TabChanging
!embed
!embed
    ELSE
!embed
    END
!embed
  OF ?Tab:1
!embed
    CASE EVENT()
!embed
    ELSE
!embed
    END
!embed
  OF ?EMB:EmbedID:Prompt
!embed
    CASE EVENT()
!embed
    ELSE
!embed
    END
!embed
  OF ?EMB:EmbedID
!embed
    CASE EVENT()
!embed
    ELSE
!embed
    END
!embed
  OF ?EMB:EmbedProcID:Prompt
!embed
    CASE EVENT()
!embed
    ELSE
!embed
    END
!embed
  OF ?EMB:EmbedProcID
!embed
    CASE EVENT()
!embed
    ELSE
!embed
    END
!embed
  OF ?EMB:LinesOfCode:Prompt
!embed
    CASE EVENT()
!embed
    ELSE
!embed
    END
!embed
  OF ?EMB:LinesOfCode
!embed
    CASE EVENT()
!embed
    ELSE
!embed
    END
!embed
  OF ?EMB:Embed:Prompt
!embed
    CASE EVENT()
!embed
    ELSE
!embed
    END
!embed
  OF ?EMB:Embed
!embed
  END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeWindowEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receives all window specific events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
!embed
  ReturnValue = PARENT.TakeWindowEvent()
!embed
    CASE EVENT()
    OF EVENT:AlertKey
!embed
    OF EVENT:CloseDown
!embed
    OF EVENT:CloseWindow
!embed
    OF EVENT:DoResize
!embed
    OF EVENT:GainFocus
!embed
    OF EVENT:Iconize
!embed
    OF EVENT:Iconized
!embed
    OF EVENT:LoseFocus
!embed
    OF EVENT:Maximize
!embed
    OF EVENT:Maximized
!embed
    OF EVENT:Move
!embed
    OF EVENT:Moved
!embed
    OF EVENT:Notify
!embed
    OF EVENT:OpenWindow
!embed
    OF EVENT:PreAlertKey
!embed
    OF EVENT:Restore
!embed
    OF EVENT:Restored
!embed
    OF EVENT:Size
!embed
    OF EVENT:Sized
!embed
!embed
    ELSE
!embed
    END
!embed
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
!embed
  RETURN ReturnValue


ThisWindow.Update PROCEDURE

!embed
  CODE
!embed
  PARENT.Update
!embed
!embed


Toolbar.DisplayButtons PROCEDURE

!embed
  CODE
!embed
  PARENT.DisplayButtons
!embed


Toolbar.Init PROCEDURE

!embed
  CODE
!embed
  PARENT.Init
!embed


Toolbar.Kill PROCEDURE

!embed
  CODE
!embed
  PARENT.Kill
!embed


Toolbar.TakeEvent PROCEDURE(<*LONG VCR>,WindowManager WM)

!embed
  CODE
!embed
  PARENT.TakeEvent(VCR,WM)
!embed

!embed

Resizer.GetParentControl PROCEDURE(SIGNED Control)

ReturnValue          SIGNED,AUTO

!embed

  CODE
!embed
  ReturnValue = PARENT.GetParentControl(Control)
!embed
  RETURN ReturnValue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)

!embed

  CODE
!embed
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
!embed
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window
!embed


Resizer.Reset PROCEDURE

!embed

  CODE
!embed
  PARENT.Reset
!embed


Resizer.Resize PROCEDURE

ReturnValue          BYTE,AUTO

!embed

  CODE
!embed
  ReturnValue = PARENT.Resize()
!embed
  RETURN ReturnValue


Resizer.Resize PROCEDURE(SIGNED Control)

ReturnValue          BYTE,AUTO

!embed

  CODE
!embed
  ReturnValue = PARENT.Resize(Control)
!embed
  RETURN ReturnValue


Resizer.RestoreWindow PROCEDURE

!embed

  CODE
!embed
  PARENT.RestoreWindow
!embed


Resizer.SetParentDefault PROCEDURE

!embed

  CODE
!embed
  PARENT.SetParentDefault
!embed


Resizer.SetParentDefaults PROCEDURE

!embed

  CODE
!embed
  PARENT.SetParentDefaults
!embed


Resizer.SetPosition PROCEDURE(SIGNED Control,*PositionGroup ParentOrigPos,*PositionGroup ParentNewPos,*PositionGroup OrigPos,*PositionGroup NewPos)

!embed

  CODE
!embed
  PARENT.SetPosition(Control,ParentOrigPos,ParentNewPos,OrigPos,NewPos)
!embed

!embed
